package lab.data;

import java.util.List;

import jakarta.persistence.Entity;
import jakarta.persistence.GeneratedValue;
import jakarta.persistence.GenerationType;
import jakarta.persistence.Id;
import jakarta.persistence.OneToMany;
import lab.Tools;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.EqualsAndHashCode;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;
import lombok.ToString;

@Entity
@Getter
@Setter
@AllArgsConstructor
@NoArgsConstructor
@EqualsAndHashCode(onlyExplicitlyIncluded = true)
@ToString
@Builder(toBuilder = true)
public class Game implements MyEntity {

	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	@EqualsAndHashCode.Include
	private Long id;
	private String name;
	@OneToMany(mappedBy = Score_.GAME)
	@ToString.Exclude
	private List<Score> scores;

	public static Game generate() {
		return new Game(null, Tools.randomGameName(), null);
	}

	public static Game generateAny() {
		return switch (Tools.RANDOM.nextInt(3)) {
		case 0 -> generate();
		case 1 -> PlatformGame.generate();
		case 2 -> FirstPersonShooter.generate();
		default -> generate();
		};
	}
}
